// BarcodeReader.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

#include "../SoftekBarcodeDLL.h"


int _tmain(int argc, _TCHAR* argv[])
{
	// Create a handle to the barcode SDK
	void *hBarcode = mtCreateBarcodeInstance();

	// Get a 30-day key from sales@bardecode.com and enter below to suppress the pop up box
	// mtSetLicenseKey(hBarcode, "MY LICENSE KEY");

	// Set some properties
	mtSetReadQRCode(hBarcode, true); // Read QR Codes
	mtSetMinLength(hBarcode, 3); // Set a minimum length of 3 (default is 4)

	int n = mtScanBarCode(hBarcode, "../Images/qrcode/qrcode01.jpg");

	if (n < 0) {
		printf ("Error code %d, SDK error %d\n", n, mtGetLastError(hBarcode));
	} else if (n == 0) {
		printf ("No barcodes found in this image\n");
	} else {
		for (int i = 1; i <= n; i++) {
			printf ("Barcode %d\n", i);
			printf ("Value %s\n", mtGetBarString(hBarcode, i));
			printf ("Type %s\n", mtGetBarStringType(hBarcode, i));
		}
	}

	mtDestroyBarcodeInstance(hBarcode);

	return 0;
}

